/*   Copyright (c) AT&T Corp.  All rights reserved.
   
This software may only be used by you under license from 
AT&T Corp. ("AT&T").  A copy of AT&T's Source Code Agreement 
is available at AT&T's Internet website having the URL 

http://www.research.att.com/sw/tools/graphviz/license/

If you received this software without first entering into a license 
with AT&T, you have an infringing copy of this software and cannot 
use it without violating AT&T's intellectual property rights. */

#include "common/Dynagraph.h"
#include <stdio.h>
#include "common/applyAttrs.h"
#include "common/emitGraph.h"
#include "common/needsQuotes.h"

inline bool needsQuotes(const DString &s) {
	return needsQuotes(s.c_str());
}
ostream &operator<<(ostream &os,const maybequote &mq) {
	if(mq.s.empty())
		os << "\"\"";
	else if(needsQuotes(mq.s))
		os << '"' << mq.s << '"';
	else
		os << mq.s;
	return os;
}
void emitAttrs(ostream &os,const StrAttrs &attrs,const DString &id) {
	bool comma=false;
	os << "[";
	if(!id.empty()) {
		os << "id=" << id;
		comma = true;
	}
	for(StrAttrs::const_iterator ai = attrs.begin(); ai!=attrs.end(); ++ai) {
		if(comma)
			os << ", ";
		os << maybequote(ai->first) << "=" << maybequote(ai->second);
		comma = true;
	}
	os << "]" << endl;
}
