# Generated automatically from graphviz.spec.in by configure.

Name:           graphviz
Prefix:		/usr
Version:        1.8.9
Release:        0
Group:          Applications/Graphics
License:        AT&T open source (see COPYING)
URL:            http://www.graphviz.org/
Summary:        Graph Visualization Tools
Packager:       John Ellson (ellson@lucent.com)
Source:         http://www.graphviz.org/pub/graphviz/graphviz-%{version}.tar.gz
BuildRoot:      /var/tmp/%{name}-root
Requires:	freetype libjpeg libpng zlib

%description
A collection of tools and tcl packages for the manipulation and layout
of graphs (as in nodes and edges, not as in barcharts).

%package graphs
Group: Applications/Graphics
Summary: Demo graphs for %{name}
Provides: %{name}-graphs = %{version}

%description graphs
The %{name}-graphs package provides some example graphs.

%package tcl
Group: Applications/Graphics
Summary: Tcl extension tools for version %{version} of %{name}
Requires: tcl tk freetype libjpeg libpng zlib
Provides: %{name}-tcl = %{version}

%description tcl
The %{name}-tcl package contains the various tcl packages (extensions)
using version %{version} of the %{name}.

%package devel
Group: Development/Libraries
Summary: Development tools for version %{version} of %{name}
Requires: graphviz
Provides: %{name}-devel = %{version}

%description devel
The %{name}-devel package contains the header files and static
libraries necessary for developing programs using version %{version}
of the %{name} libraries.

%prep
%setup -n %{name}-%{version}

%ifarch i386
CFLAGS="$RPM_OPT_FLAGS -ffast-math" ./configure --prefix=%{prefix} --with-x --sysconfdir=/etc --infodir=%{_infodir} --mandir=%{_mandir} --sharedstatedir=/var/state/ --with-dynagraph
%else
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} --with-x --with-tcl=/usr --sysconfdir=/etc --infodir=%{_infodir} --mandir=%{_mandir} --sharedstatedir=/var/state/ --with-dynagraph
%endif

%build
make DESTDIR=$RPM_BUILD_ROOT docdir=$RPM_BUILD_ROOT/%{_docdir}/%{name}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT docdir=$RPM_BUILD_ROOT/%{_docdir}/%{name}
%{?suse_check}

%files
%defattr(-,root,root)
%doc FAQ.txt AUTHORS COPYING MINTERMS.txt README NEWS
%doc doc
%doc %{_mandir}/man1
%{_bindir}/dot
%{_bindir}/neato
%{_bindir}/twopi
%{_bindir}/dotty
%{_bindir}/lefty
%{_bindir}/lneato
%{_bindir}/acyclic
%{_bindir}/ccomps
%{_bindir}/colorize
%{_bindir}/gc
%{_bindir}/nop
%{_bindir}/sccmap
%{_bindir}/unflatten
%{_bindir}/tred
%{_bindir}/gpr
%{_bindir}/prune
%{_bindir}/dynagraph
%{_bindir}/graphsearch
%{prefix}/share/graphviz/lefty/box.lefty
%{prefix}/share/graphviz/lefty/def.lefty
%{prefix}/share/graphviz/lefty/dotty.lefty
%{prefix}/share/graphviz/lefty/dotty_draw.lefty
%{prefix}/share/graphviz/lefty/dotty_edit.lefty
%{prefix}/share/graphviz/lefty/dotty_layout.lefty
%{prefix}/share/graphviz/lefty/dotty_ui.lefty
%{prefix}/share/graphviz/lefty/fractal.lefty
%{prefix}/share/graphviz/lefty/fractal2.lefty
%{prefix}/share/graphviz/lefty/lefty.psp
%{prefix}/share/graphviz/lefty/slides.lefty
%{prefix}/share/graphviz/lefty/tree.lefty

%files graphs
%defattr(-,root,root)
%{prefix}/share/graphviz/graphs/directed/*.dot
%{prefix}/share/graphviz/graphs/undirected/*.dot

%files tcl
%defattr(-,root,root)
%doc %{_mandir}/mann
%{_libdir}/%{name}/libagraph.*
%{_libdir}/%{name}/libcdt.*
%{_libdir}/%{name}/libexpr.*
%{_libdir}/%{name}/libgraph.*
%{_libdir}/%{name}/libgd.*
%{_libdir}/%{name}/libpack.*
%{_libdir}/%{name}/libpathplan.*
%{_libdir}/%{name}/libgdtclft.*
%{_libdir}/%{name}/libtcldgl.*
%{_libdir}/%{name}/libtcldgr.*
%{_libdir}/%{name}/libtcldot.*
%{_libdir}/%{name}/libtclplan.*
%{_libdir}/%{name}/libtkspline.*
%{_libdir}/%{name}/pkgIndex.tcl
%{prefix}/share/graphviz/demo/dge
%{prefix}/share/graphviz/demo/dge.README
%{prefix}/share/graphviz/demo/dge.example1.dot
%{prefix}/share/graphviz/demo/dge.example2.dot
%{prefix}/share/graphviz/demo/gcat
%{prefix}/share/graphviz/demo/gcat.README
%{prefix}/share/graphviz/demo/doted
%{prefix}/share/graphviz/demo/doted.README
%{prefix}/share/graphviz/demo/entities
%{prefix}/share/graphviz/demo/entities.README
%{prefix}/share/graphviz/demo/entities.html
%{prefix}/share/graphviz/demo/ihi
%{prefix}/share/graphviz/demo/ihi.README
%{prefix}/share/graphviz/demo/ihi.testdata
%{prefix}/share/graphviz/demo/pathplan
%{prefix}/share/graphviz/demo/pathplan.README
%{prefix}/share/graphviz/demo/pathplan_data/boxes.dat
%{prefix}/share/graphviz/demo/pathplan_data/funny.dat
%{prefix}/share/graphviz/demo/pathplan_data/nested.dat
%{prefix}/share/graphviz/demo/pathplan_data/obs.dat
%{prefix}/share/graphviz/demo/pathplan_data/paths.dat
%{prefix}/share/graphviz/demo/pathplan_data/u.dat
%{prefix}/share/graphviz/demo/pathplan_data/dpd.dat
%{prefix}/share/graphviz/demo/pathplan_data/maze.dat
%{prefix}/share/graphviz/demo/pathplan_data/northo.dat
%{prefix}/share/graphviz/demo/pathplan_data/other.dat
%{prefix}/share/graphviz/demo/pathplan_data/rotor.dat
%{prefix}/share/graphviz/demo/pathplan_data/unknown.dat
%{prefix}/share/graphviz/demo/spline
%{prefix}/share/graphviz/demo/spline.README

%files devel
%defattr(-,root,root)
%{_includedir}/%{name}
%doc %{_mandir}/man3

%clean
rm -rf $RPM_BUILD_ROOT
